
#include "TAlSAMURAICoinExample.hh"

#include <iostream>

#include "TClonesArray.h"
#include "TMath.h"

#include "TArtAnaFile.hh"
#include "TArtAnaClock.hh"
#include "TArtAnaLoopManager.hh"

#include "TArtCalibCoin.hh"
#include "TArtEventInfo.hh"

#include "EAnalyser.hh"
#include "EWNum.hh"

#include "TArtStoreManager.hh"
//____________________________________________________________________________
TAlSAMURAICoinExample::TAlSAMURAICoinExample()
  : TArtAnaLoop(), calibcoin(0)
{;}

//____________________________________________________________________________
TAlSAMURAICoinExample::~TAlSAMURAICoinExample()
{
  Destruct();
}
//____________________________________________________________________________
void TAlSAMURAICoinExample::Construct()
{
  calibcoin = new TArtCalibCoin; 
}

//____________________________________________________________________________
void TAlSAMURAICoinExample::Calculate()
{
  calibcoin->LoadData();

  TArtStoreManager * sman = TArtStoreManager::Instance();
  TClonesArray *info = (TClonesArray*)sman->FindDataContainer("EventInfo");
  int runnumber = ((TArtEventInfo *)info->At(0))->GetRunNumber();
  int evenumber = ((TArtEventInfo *)info->At(0))->GetEventNumber();
  unsigned int tbit = ((TArtEventInfo *)info->At(0))->GetTriggerBit();
  //  TArtCore::Info(__FILE__,"tbit: %x", tbit);

  using namespace Analyser;
  using namespace WNum::GLOBAL;  

  Add(GLOBAL, RUNNUM,           0, (Double_t)runnumber);
  Add(GLOBAL, EVENTNUM,         0, (Double_t)evenumber);
  Add(GLOBAL, TRIGGERBIT,       0, (Double_t)tbit);
  for (int id=1; id<=16; id++){
    if(calibcoin->IsChTrue(id)){
      Add(GLOBAL, TRIGGERBIT, id, id);
    }
  }
}

//____________________________________________________________________________
void TAlSAMURAICoinExample::Destruct()
{
  delete calibcoin;
  calibcoin = 0;
}

//____________________________________________________________________________
const char* TAlSAMURAICoinExample::ClassName() const
{
  return "TAlSAMURAICoinExample";
}
