// rips reconstruction class
// 

#ifndef _TARTRECORIPS_H_
#define _TARTRECORIPS_H_

#include <TNamed.h>
#include <TMatrixD.h>
#include <TClonesArray.h>

#include "TArtReconstruction.hh"

class TArtBigRIPSParameters;
class TArtFocalPlane;
class TArtRIPS;
class TArtStoreManager;

class TArtRecoRIPS : public TArtReconstruction {

 public:

  TArtRecoRIPS();
  virtual ~TArtRecoRIPS();

  void ClearData();
  void ReconstructData();

  TArtRIPS * DefineNewRIPS(Int_t ffpl, Int_t bfpl, char *file, Double_t brho);
  TArtRIPS * DefineNewRIPS(Int_t ffpl, Int_t bfpl, TMatrixD *mat, Double_t brho);

  // function to access data container
  TClonesArray    * GetRIPSArray(){return fRIPSArray;}
  Int_t             GetNumRIPS();
  // get i-th object in array
  TArtRIPS  * GetRIPS(Int_t i);
  // looking for fpl object whose forward fpl-number is f_fpl and backward fpl-number is b_fpl. return NULL in the case of fail to find.
  TArtRIPS  * FindRIPS(Int_t f_fpl, Int_t b_fpl);

 private:

  TClonesArray       * fRIPSArray;
  TArtBigRIPSParameters * setup;
  TArtStoreManager * sman;

  std::vector <TArtFocalPlane*> fUpstreamFplArrayBuffer;
  std::vector <TArtFocalPlane*> fDownstreamFplArrayBuffer;

  ClassDef(TArtRecoRIPS,1);

};

#endif
