// SAMURAI Fragment reconstruction class
// 

#ifndef _TARTRECOFRAGMENT_H_
#define _TARTRECOFRAGMENT_H_

#include "TArtReconstruction.hh"
#include "TMatrixD.h"

class TClonesArray;
class TArtStoreManager;
class TArtPlastic;

class TArtRecoFragment : public TArtReconstruction {

public:

  TArtRecoFragment();
  virtual ~TArtRecoFragment();

  virtual void ClearData();
  virtual void ReconstructData();

  virtual void SetCenterBrho(Double_t v){center_brho = v;}
  virtual void SetTOFOffSet(Double_t v){tof_offset = v;}
  virtual void SetPla2TargetLength(Double_t v){l_pla2target = v;}
  virtual Double_t GetCenterBrho(){return center_brho;}
  virtual Double_t GetTOFOffSet(){return tof_offset;}
  virtual Double_t GetPla2TargetLength(){return l_pla2target;}

private:

  TClonesArray * fFragmentArray;
  TClonesArray * hod_array;
  TArtStoreManager * sman;

  TArtPlastic * pla_tzero;
  Double_t l_pla2target; // distance of tzero-pla to target
  Double_t tof_offset; // tof offset
  Double_t clight; // speed of light
  Double_t mnucleon; // mass of nucleon

  TMatrixD mat0;
  TMatrixD mat1;
  TMatrixD mat2;
  TMatrixD inv_mat2;

  bool fMatReady;
  bool fRKtraceReady;
  Double_t center_brho;

  ClassDef(TArtRecoFragment,1)

};

#endif
